/*****************************************************************************

				WWIV Version 4
                    Copyright (C) 1988-1993 by Wayne Bell

Distribution of the source code for WWIV, in any form, modified or unmodified,
without PRIOR, WRITTEN APPROVAL by the author, is expressly prohibited.
Distribution of compiled versions of WWIV is limited to copies compiled BY
THE AUTHOR.  Distribution of any copies of WWIV not compiled by the author
is expressly prohibited.


*****************************************************************************/



#include "vars.h"

#pragma hdrstop

#include <dir.h>
#include <math.h>



/* functions for external programs to call */

#pragma warn -par

void far interrupt inlii(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, char *s2, int i1, int i2)
{
  inli(s1,s2,i1,i2);
}

void far interrupt checkai(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int *i1, int *i2)
{
  checka(i1,i2);
}


void far interrupt plai(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int *i1)
{
  pla(s1,i1);
}


void far interrupt outchri(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char ch)
{
  outchr(ch);
}


void far interrupt outstri(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  outstr(s1);
}


void far interrupt nli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  nl();
}


void far interrupt pli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  pl(s1);
}


void far interrupt emptyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=empty();
}


void far interrupt inkeyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=(unsigned) empty();
}


void far interrupt getkeyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=(unsigned) getkey();
}


void far interrupt inputi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int i)
{
  input(s1,i);
}


void far interrupt inputli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1, int i)
{
  inputl(s1,i);
}


void far interrupt yni(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=yn();
}



void far interrupt nyi(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags)
{
  ax=ny();
}


void far interrupt ansici(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1)
{
  ansic(i1);
}


void far interrupt oneki(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           char *s1)
{
  ax=(unsigned) onek(s1);
}


void far interrupt prti(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1, char *s1)
{
  prt(i1,s1);
}



void far interrupt mpli(unsigned bp, unsigned di, unsigned si,
                           unsigned ds, unsigned es, unsigned dx,
                           unsigned cx, unsigned bx, unsigned ax,
                           unsigned ip, unsigned cs, unsigned flags,
                           int i1)
{
  mpl(i1);
}


#pragma warn +par

/* end of functions for external programs to call */


void reset_act_sl(void)
{
  actsl = thisuser.sl;
}


void remove_from_temp(char *fn, char *dir, int po)
{
  int i,i1,f1,ok;
  char s[81],s1[81];
  struct ffblk ff;
  uploadsrec u;

  sprintf(s1,"%s%s",dir,stripfn(fn));
  f1=findfirst(s1,&ff,0);
  ok=1;
  nl();
  while ((f1==0) && (ok)) {
    sprintf(s,"%s%s",dir,ff.ff_name);
    if (po)
      outstr(get_string(919));
      pl(ff.ff_name);
    _chmod(s,1,0);
    unlink(s);
    f1=findnext(&ff);
  }
}

void check_event(void)
{
  double tl;

  if (syscfg.executetime) {
    tl=time_event-timer();
    if (tl<0.0)
      tl += 24.0*3600.0;
    if ((tl-last_time)>30.0)
      do_event=1;
    last_time=tl;
  }
}


void run_event(void)
{
  if ((do_event) && (syscfg.executetime)) {
    do_event=0;
    nl();
    pl(get_string(920));
    nl();
    if (syscfg.executestr[0]) {
      holdphone(1);
      shrink_out(syscfg.executestr,0,0,0,1);
      /* run_external(syscfg.executestr); */
      holdphone(0);
    } else
      end_bbs(oklevel);
  }
  clrscrb();
}


double freek(int dr)
{
  float d;
  struct dfree df;

  getdfree(dr,&df);
  d=(float) df.df_avail;
  d*=((float) df.df_bsec);
  d*=((float) df.df_sclus);
  d/=1024.0;
  if (df.df_sclus==0xffff)
    d=-1.0;
  return(d);
}


unsigned char years_old(unsigned char m, unsigned char d, unsigned char y)
{
  struct date today;
  int a;

  getdate(&today);

  if (today.da_year-1900<y)
    return(0);
  if (today.da_year-1900==y) {
    if (today.da_mon<m)
      return(0);
    if (today.da_mon==m) {
      if (today.da_day<d)
        return(0);
    }
  }

  a=(int) (today.da_year-1900-y);
  if (today.da_mon<m)
    --a;
  else
    if ((today.da_mon==m) && (today.da_day<d))
      --a;
  return((unsigned char)a);
}



void itimer(void)
/* This function initializes the high-resolution timer */
{
  outportb(0x43,0x34);
  outportb(0x40,0x00);
  outportb(0x40,0x00);

}

double timer(void)
/* This function returns the time, in seconds since midnight. */
{
  double cputim;
  unsigned short int h,m,l1,l2;

  disable();
  outportb(0x43,0x00);
  m=peek(0x0040,0x006c);
  h=peek(0x0040,0x006e);
  l1=inportb(0x40);
  l2=inportb(0x40);
  enable();
  l1=((l2*256)+l1) ^ 65535;
  cputim=((h*65536. + m)*65536. + l1)*8.380955e-7;
  return (cputim);
}


long timer1(void)
/* This function returns the time, in ticks since midnight. */
{
  unsigned short h,m;
  long l;

  m=peek(0x0040,0x006c);
  h=peek(0x0040,0x006e);
  l=((long)h)*65536 + ((long)m);
  return(l);
}


int sysop1(void)
/* This function returns the status of scoll lock.  If scroll lock is active
 * (ie, the user has hit scroll lock + the light is lit if there is a
 * scoll lock LED), the sysop is assumed to be available.
 */
{
  if ((peekb(0,1047) & 0x10)==0)
    return(0);
  else
    return(1);
}



int okansi(void)
/* This function checks the status of the current user's record to see if
 * the user has specified that he wants ANSI graphics displayed.
 */
{
  if (x_only)
    return(0);
  if (thisuser.sysstatus & sysstatus_ansi)
    return(1);
  else
    return(0);
}


void frequent_init(void)
/* This should be called after a user is logged off, and will initialize
 * screen-access variables.
 */
{
  in_fsed=0;
  curlsub=-1;
  ansiptr=0;
  curatr=0x07;
  outcom=0;
  incom=0;
  charbufferpointer=0;
  andwith=0xff;
  checkit=0;
  topline=0;
  screenlinest=defscreenbottom+1;
  if (!restoring_shrink)
    clrscrb();
  endofline[0]=0;
  hangup=0;
  hungup=0;
  chatcall=0;
  chatreason[0]=0;
  useron=0;
  change_color=0;
  chatting=0;
  echo=1;
  irt[0]=0;
  irt_name[0]=0;
  okskey=0;
  lines_listed=0;
  read_user(1,&thisuser);
  read_qscn(1,qsc,0);
  if (thisuser.inact & inact_deleted)
    fwaiting=0;
  else
    fwaiting=thisuser.waiting;
  okmacro=1;
  okskey=1;
  helpl=0;
  ihelp=0;
  mailcheck=0;
  smwcheck=0;
  in_extern=0;
  gatfn[0]=0;
  use_workspace=0;
  extratimecall=0.0;
  two_color=0;
  using_modem=0;
  set_global_handle(0);
  live_user=1;
  _chmod(dszlog,1,0);
  unlink(dszlog);
  ltime=0;
  set_x_only(0, NULL, 0);
  set_net_num(0);
  set_language(0);
}


void fix_user_rec(userrec *u)
{
  u->name[sizeof(u->name)-1]=0;
  u->realname[sizeof(u->realname)-1]=0;
  u->callsign[sizeof(u->callsign)-1]=0;
  u->phone[sizeof(u->phone)-1]=0;
  u->pw[sizeof(u->pw)-1]=0;
  u->laston[sizeof(u->laston)-1]=0;
  u->note[sizeof(u->note)-1]=0;
  u->macros[0][sizeof(u->macros[0])-1]=0;
  u->macros[1][sizeof(u->macros[1])-1]=0;
  u->macros[2][sizeof(u->macros[2])-1]=0;
}

void close_user(void)
{
  if (userfile!=-1) {
    close(userfile);
    userfile=-1;
  }
}

void open_user(void)
{
  char s[81];

  if (userfile==-1) {
    sprintf(s,"%sUSER.LST",syscfg.datadir);
    userfile=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
    if (userfile<0) {
      userfile=-1;
    }
  }
}


int number_userrecs(void)
{
  open_user();
  return((int) (filelength(userfile)/syscfg.userreclen)-1);
}

void read_user(unsigned int un, userrec *u)
{
  long pos;
  char s[80];
  int i;

  open_user();
  if ((userfile<0) || (un>number_userrecs())) {
    u->inact=inact_deleted;
    fix_user_rec(u);
    return;
  }

  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    *u=thisuser;
    fix_user_rec(u);
    return;
  }
  pos=((long) syscfg.userreclen) * ((long) un);
  lseek(userfile,pos,SEEK_SET);
  read(userfile, (void *)u, syscfg.userreclen);
  fix_user_rec(u);
}


void write_user(unsigned int un, userrec *u)
{
  long pos;
  char s[80];
  unsigned char oldsl;
  int i;

  open_user();

  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    thisuser=*u;
  }
  pos=((long) syscfg.userreclen) * ((long) un);
  lseek(userfile,pos,SEEK_SET);
  write(userfile, (void *)u, syscfg.userreclen);
}

/****************************************************************************/

int qscn_file=-1;

int open_qscn(void)
{
  char s[81];

  if (qscn_file==-1) {
    sprintf(s,"%sUSER.QSC",syscfg.datadir);
    qscn_file=open(s,O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE);
    if (qscn_file<0) {
      qscn_file=-1;
      return(0);
    }
  }
  return(1);
}

void close_qscn(void)
{
  if (qscn_file!=-1) {
    close(qscn_file);
    qscn_file=-1;
  }
}

void read_qscn(unsigned int un, unsigned long *qscn, int stayopen)
{
  long pos;
  int i;

  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    for (i=(syscfg.qscn_len/4)-1; i>=0; i--)
      qscn[i]=qsc[i];
    return;
  }

  if (open_qscn()) {
    pos=((long)syscfg.qscn_len)*((long)un);
    if (pos + (long)syscfg.qscn_len <= filelength(qscn_file)) {
      lseek(qscn_file,pos,SEEK_SET);
      read(qscn_file,qscn,syscfg.qscn_len);
      if (!stayopen)
        close_qscn();
      return;
    }
  }

  if (!stayopen)
    close_qscn();

  memset(qsc, 0, syscfg.qscn_len);
  *qsc=999;
  memset(qsc+1,0xff,((syscfg.max_dirs+31)/32)*4);
  memset(qsc+1+(syscfg.max_dirs+31)/32,0xff,((syscfg.max_subs+31)/32)*4);
}

void write_qscn(unsigned int un, unsigned long *qscn, int stayopen)
{
  long pos;
  int i;

  if (((useron) && (un==usernum)) || ((wfc) && (un==1))) {
    for (i=(syscfg.qscn_len/4)-1; i>=0; i--)
      qsc[i]=qscn[i];
  }

  if (open_qscn()) {
    pos=((long)syscfg.qscn_len)*((long)un);
    lseek(qscn_file,pos,SEEK_SET);
    write(qscn_file,qscn,syscfg.qscn_len);
    if (!stayopen)
      close_qscn();
  }
}

/****************************************************************************/

void save_status(void)
{
  char s[80];

  sprintf(s,"%sSTATUS.DAT",syscfg.datadir);
  statusfile=open(s,O_RDWR | O_BINARY);
  write(statusfile, (void *)(&status), sizeof(statusrec));
  close(statusfile);
  statusfile=-1;
}




double ratio(void)
{
  double r;

  if (thisuser.dk==0)
    return(99.999);
  r=((float) thisuser.uk) / ((float) thisuser.dk);
  if (r>99.998)
    r=99.998;
  return(r);
}


double post_ratio(void)
{
  double r;

  if (thisuser.logons==0)
    return(99.999);
  r=((float) thisuser.msgpost) / ((float) thisuser.logons);
  if (r>99.998)
    r=99.998;
  return(r);
}


char *nam(userrec *u1, unsigned int un)
{
  static char o[81];
  int i,f,p;
  userrec u;

  u=*u1;
  f=1;
  for (p=0; p<strlen(u.name); p++) {
    if (f) {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
	f=0;
      o[p]=u.name[p];
    } else {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
        o[p]=u.name[p]-'A'+'a';
      else {
        if ((u.name[p]>=' ') && (u.name[p]<='/'))
          f=1;
        o[p]=u.name[p];
      }
    }
  }
  o[p++]=32;
  o[p++]='#';
  itoa(un,&o[p],10);
  return(o);
}


char *nam1(userrec *u1, unsigned int un, unsigned int sy)
{
  static char o[81];
  char s[10];

  strcpy(o,nam(u1,un));
  if (sy) {
    sprintf(s," @%u",sy);
    strcat(o,s);
  }
  return(o);
}

double nsl(void)
{
  double tlt,tlc,tot,tpl,tpd,dd,rtn;
  slrec xx;

  dd=timer();
  if (useron) {
    if (timeon>(dd+60.0))
      timeon -= 24.0*3600.0;
    tot=(dd-timeon);
    xx=syscfg.sl[actsl];
    tpl=((double) xx.time_per_logon) * 60.0;
    tpd=((double) xx.time_per_day) * 60.0;
    tlc = tpl - tot + (thisuser.extratime) + extratimecall;
    tlt = tpd - tot - ((double) thisuser.timeontoday) + (thisuser.extratime);

    tlt=(((tlc)<(tlt)) ? (tlc) : (tlt));
    if (tlt<0.0)
      tlt=0.0;
    if (tlt>32767.0)
      tlt=32767.0;
    rtn=tlt;
  } else {
    rtn=1.00;
  }
  ltime=0;
  if (syscfg.executetime) {
    tlt=time_event-dd;
    if (tlt<0.0)
      tlt += 24.0*3600.0;
    if (rtn>tlt) {
      rtn=tlt;
      ltime=1;
    }
    check_event();
    if (do_event)
      rtn=0.0;
  }
  if (rtn<0.0)
    rtn=0.0;
  if (rtn>32767.0)
    rtn=32767.0;
  return(rtn);
}


char *date(void)
{
  static char ds[9];
  struct date today;

  getdate(&today);
  sprintf(ds,"%02d/%02d/%02d",today.da_mon,today.da_day,today.da_year-1900);
  return(ds);
}

char *times(void)
{
  static char ti[9];
  int h,m,s;
  double t;

  t=timer();
  h=(int) (t/3600.0);
  t-=((double) (h)) * 3600.0;
  m=(int) (t/60.0);
  t-=((double) (m)) * 60.0;
  s=(int) (t);
  sprintf(ti,"%02d:%02d:%02d",h,m,s);
  return(ti);
}


unsigned int finduser(char *s)
{
  int un;
  smalrec *sr;
  userrec u;
  char *ss;

  if (strcmp(s,"NEW")==0)
    return(-1);
  if (strcmp(s,"!-@NETWORK@-!")==0)
    return(-2);
  if (strcmp(s,"!-@REMOTE@-!")==0)
    return(-3);
  if (strncmp(s,"!=@",3)==0) {
    ss=s+strlen(s)-3;
    if (strcmp(ss,"@=!")==0) {
      strcpy(s,s+3);
      s[strlen(s)-3]=0;
      return(-4);
    }
  }

  if ((un=atoi(s))>0) {
    if (un>number_userrecs())
      return(0);
    read_user(un,&u);
    if (u.inact & inact_deleted)
      return(0);
    return(un);
  }

  sr=(smalrec *) bsearch((void *)s,
			 (void *)smallist,
			 (size_t)status.users,
			 (size_t)sizeof(smalrec),
			 (int _Cdecl (*) (const void *, const void *))strcmp);
  if (sr==0L)
    return(0);
  else {
    read_user(sr->number,&u);
    if (u.inact & inact_deleted)
      return(0);
    else
      return(sr -> number);
  }
}


void changedsl(void)
{
  int i,i1,i2,i3,i4,ok,dp,ddp, tp, dtp;
  subboardrec s;
  directoryrec d;
  usersubrec s1;

  topscreen();
  dp=ddp=tp=dtp=0;
  dc[dp++]='/';
  dcd[ddp++]='/';
  s1.subnum=-1;
  s1.keys[0]=0;
  for (i=0; i<max_subs; i++)
    usub[i]=s1;
  for (i=0; i<max_dirs; i++)
    udir[i]=s1;
  i1=1;
  i2=0;
  i3=0;
  for (i=0; i<num_subs; i++) {
    ok=1;
    s=subboards[i];
    if (actsl<s.readsl)
      ok=0;
    if (thisuser.age<(s.age&0x7f))
      ok=0;
    if ((s.ar!=0) && (((thisuser.ar) & (s.ar))==0))
      ok=0;
    if ((s.anony & anony_ansi_only) && (!okansi()))
      ok=0;
    if (ok) {
      s1.subnum=i;
      if (s.key!=0) {
        s1.keys[0]=s.key;
        s1.keys[1]=0;
        usub[i3++]=s1;
      } else {
        if (i1<100) {
          if ((i1 % 10)==0)
            dc[dp++]=('0'+(i1/10));
        } else {
          if ((i1 % 100)==0)
            tc[tp++]=('0'+(i1/100));
        }
        itoa(i1++,s1.keys,10);
        for (i4=i3; i4>i2; i4--)
          usub[i4]=usub[i4-1];
        i3++;
        usub[i2++]=s1;
      }
    }
  }
  i1=1;
  i2=0;
  for (i=0; i<num_dirs; i++) {
    ok=1;
    d=directories[i];
    if (thisuser.dsl<d.dsl)
      ok=0;
    if (thisuser.age<d.age)
      ok=0;
    if (d.dar)
      if ((d.dar & thisuser.dar)==0)
        ok=0;
    if (ok) {
      s1.subnum=i;
      if (i==0)
        strcpy(s1.keys,"0");
      else {
        if (i1<100) {
          if ((i1 % 10)==0)
            dcd[ddp++]=('0'+(i1/10));
        } else {
          if ((i1 % 100)==0)
            dtc[dtp++]=('0'+(i1/100));
        }
        itoa(i1++,s1.keys,10);
      }
      udir[i2++]=s1;
    }
  }
  dcd[ddp]=0;
  dc[dp]=0;
  tc[tp]=0;
  dtc[dtp]=0;
}


void isr(int un, char *name)
{
  int cp,i;
  char s[81];
  smalrec sr;

  cp=0;
  while ((cp<status.users) && (strcmp(name,(smallist[cp].name))>0))
    ++cp;
  memmove(&(smallist[cp+1]),&(smallist[cp]),sizeof(smalrec)*(status.users-cp));
  strcpy(sr.name,name);
  sr.number=un;
  smallist[cp]=sr;
  sprintf(s,"%sNAMES.LST",syscfg.datadir);
  i=open(s,O_RDWR | O_BINARY | O_TRUNC);
  if (i<0) {
    printf("%s NOT FOUND.\n",s);
    end_bbs(noklevel);
  }
  ++status.users;
  save_status();
  write(i,(void *) (smallist), (sizeof(smalrec) * status.users));
  close(i);
}


void dsr(char *name)
{
  int cp,i;
  char s[81];
  smalrec sr;

  cp=0;
  while ((cp<status.users) && (strcmp(name,(smallist[cp].name))!=0))
    ++cp;
  if (strcmp(name,(smallist[cp].name))) {
    sprintf(s,get_stringx(1,74),name);
    sl1(0,s);
    sl1(0,get_stringx(1,75));
    return;
  }
  memmove(&(smallist[cp]),&(smallist[cp+1]),sizeof(smalrec)*(status.users-cp));
  sprintf(s,"%sNAMES.LST",syscfg.datadir);
  i=open(s,O_RDWR | O_BINARY | O_TRUNC | O_CREAT, S_IREAD | S_IWRITE);
  if (i<0) {
    printf("%s COULDN'T BE CREATED.\n",s);
    end_bbs(noklevel);
  }
  --status.users;
  save_status();
  write(i,(void *) (smallist), (sizeof(smalrec) * status.users));
  close(i);
}


void wait(double d)
{
  long l1;

  l1=((long) (18.2*d));
  l1 += timer1();

  enable();
  while (timer1()<l1)
    ;
}

void wait1(long l)
{
  long l1;

  l1 = timer1()+l;

  enable();
  while (timer1()<l1)
    ;
}


double freek1(char *s)
{
  int d;

  d=cdir[0];
  if (s[1]==':')
    d=s[0];
  d=d-'A'+1;
  return(freek(d));
}


int exist(char *s)
{
  int i;
  struct ffblk ff;

  i=findfirst(s,&ff,FA_HIDDEN);
  if (i)
    return(0);
  else
    return(1);
}


void add_ass(int i, char *ss)
{
  char s[81],s1[10];

  strcpy(s,"*** ");
  sysoplog(s);
  strcat(s,ss);
  sysoplog(s);
  itoa(i,s1,10);
  strcpy(s,get_stringx(1,76));
  strcat(s,s1);
  sysoplog(s);
  thisuser.ass_pts += i;
}


int find_interrupt(void)
{
  long far *l;
  int i;

  for (i=0x60; i<0xf0; i++) {
    if ((i<0x70) || (i>0x77)) {
      l=MK_FP(0,(i*4));
      if (*l==0)
        return i;
    }
  }
  return(0);
}



/****************************************************************************/

void send_net(net_header_rec *nh, unsigned int *list, char *text, char *byname)
{
  int f;
  char s[100];
  long l1;

  sprintf(s,"%sP1.NET",net_data);
  f=open(s,O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
  lseek(f,0L,SEEK_END);
  if (!list)
    nh->list_len=0;
  if (!text)
    nh->length=0;
  if (nh->list_len)
    nh->tosys=0;
  l1=nh->length;
  if (byname && *byname)
    nh->length += strlen(byname)+1;
  write(f,(void *)nh,sizeof(net_header_rec));
  if (nh->list_len)
    write(f,(void *)list,2*(nh->list_len));
  if (byname && *byname)
    write(f,byname, strlen(byname)+1);
  if (nh->length)
    write(f,(void *)text,l1);
  close(f);
}

/****************************************************************************/

unsigned char dow(void)
/* returns day of week, 0=Sun, 6=Sat */
{
  unsigned char ch;

  _AH=0x2a;
  geninterrupt(0x21);
  ch=_AL;

  return(ch);
}

/****************************************************************************/

static int multitasker;

#define MT_DESQVIEW 0x01
#define MT_WINDOWS  0x02
#define MT_OS2      0x04

void detect_multitask(void)
{
  union REGS r;

  multitasker=0;

  r.x.ax=0x2b01;
  r.x.cx=0x4445;
  r.x.dx=0x5351;
  if (int86(0x21, &r, &r)&0xff != 0xff)
    multitasker |= MT_DESQVIEW;

  r.h.ah=0x30;
  if (int86(0x21,&r,&r)&0xff >= 10)
    multitasker |= MT_OS2;
}

void giveup_timeslice(void)
{
  if (multitasker & MT_DESQVIEW) {
    _AX=0x101a;
    geninterrupt(0x15);
    _AX=0x1000;
    geninterrupt(0x15);
    _AX=0x1025;
    geninterrupt(0x15);
  } else if (multitasker & MT_WINDOWS) {
  }
}

void begin_crit(void)
{
  if (multitasker & MT_DESQVIEW) {
    _AX=0x101a;
    geninterrupt(0x15);
    _AX=0x101b;
    geninterrupt(0x15);
    _AX=0x1025;
    geninterrupt(0x15);
  }
}

void end_crit(void)
{
  if (multitasker & MT_DESQVIEW) {
    _AX=0x101a;
    geninterrupt(0x15);
    _AX=0x101c;
    geninterrupt(0x15);
    _AX=0x1025;
    geninterrupt(0x15);
  }
}
